short [] eraseXloc = null ;  // set this first time entering draw() to get a valid width X height
short [] eraseYloc = null ;  // set this first time entering draw() to get a valid width X height
int eraseIndex = 0 ;         // Where to pick up in the sequence, initialize below.
void initEraseLocs(int displayWidth, int displayHeight) {
  if (eraseXloc != null || eraseYloc != null) {
    throw new java.lang.RuntimeException("ERROR, initEraseLocs called multiple times.");
  }
  // A Java short is 2 bytes, an int is 4 bytes, don't let height or width be > 32767!
  int numnums = displayWidth * displayHeight ;
  eraseXloc = new short [ numnums ];
  eraseYloc = new short [ numnums ];
  int index = 0 ;
  for (short x = 0 ; x < displayWidth ; x++) {
    for (short y = 0 ; y < displayHeight ; y++) {
      eraseXloc[index] = x ;
      eraseYloc[index] = y ;
      index++;
    }
  }
  // Now exchange each with some random location in the array to try to eliminate any patterns.
  int numnums100 = 100 * numnums ;  // Try to spread random out a lot, avoid clumping.
  eraseIndex = (int) random(0, numnums100) % numnums ; // Where to pick up in the sequence.
  for (index = 0 ; index < numnums ; index++) {
    int swapper = (int) random(0, numnums100) % numnums ;
    short tempx = eraseXloc[index];  // swap both coordinates of the location
    short tempy = eraseYloc[index];  // swap both coordinates of the location
    eraseXloc[index] = eraseXloc[swapper] ;
    eraseYloc[index] = eraseYloc[swapper] ;
    eraseXloc[swapper] = tempx ;
    eraseYloc[swapper] = tempy ;
  }
}
// This function sets RGB color mode and calls loadPixels(), updatePixels().
// colorValue is per the color(N) result, alphaValue is 0..255.
void applyEraseLocs(int colorValue, int alphaValue) {
  colorMode(RGB, 255, 255, 255, 255); // WARNING, sets ARGB mode!
  int av = constrain(alphaValue, 0, 255);
  if (av > 0) {
    if (av == 255) {
      background(red(colorValue), green(colorValue), blue(colorValue));
    } else {
      fill(colorValue, alphaValue);
      stroke(colorValue, alphaValue);
      rectMode(CORNER);
      rect(0, 0, width, height); // Paint a transparent, translucent, or opaque mask over entire 2D display.
      //loadPixels();
      //PImage mask = createImage(width, height, ARGB);
      //mask.loadPixels();
      //java.lang.System.arraycopy(pixels,0,mask.pixels,0,pixels.length);
      //
      //filter(ERODE);
      /*
      float percent = (float) alphaValue / 255.0 ;
      int pixies = constrain((int)(percent * eraseXloc.length), 1, eraseXloc.length);
      loadPixels() ;
      if (pixels.length != eraseXloc.length) {
        throw new java.lang.RuntimeException("ERROR: pixels [] length is " + pixels.length
          + ", erasure arrays are " + eraseXloc.length);
      }
      for (int i = 0 ; i < pixies ; i++) {
        pixels[eraseYloc[eraseIndex] * width + eraseXloc[eraseIndex]] = colorValue ;
        eraseIndex = (eraseIndex+1) % eraseYloc.length ;
      }
      updatePixels();
      */
    }
  }
}
