// demo1summer2011.ck -- demo Chuck state machine with only 1 state.
// Jeremy Parson Summer 2011 

MidiIn min ;
MidiOut mout ;
MidiMsg msg ;

Std.atoi(me.arg(0)) => int midiinnum ;
Std.atoi(me.arg(1)) => int midioutnum ;

if (!min.open(midiinnum)) {
    <<< "Cannot open input", me.arg(0) >>>;
    me.exit();
}

if (!mout.open(midioutnum)) {
    <<< "Cannot open input", me.arg(1) >>>;
    me.exit();
}

int toggle[10];  // used to toggle the foot switches

<<< "START MIDI TEST" >>>;
while (true) {
    min => now ;
    while (min.recv(msg)) {
        <<< "TEST: ", msg.data1, msg.data2, msg.data3 >>>;
        // Here comes the translation part:
        if (msg.data1 == 176 && (msg.data2 == 1 || msg.data2 == 7 || msg.data2 == 95 || msg.data2 == 94)) {
            // 1 and 7 are the expression pedals, 95 and 94 are the latches.
            mout.send(msg);     // echo it to output
        } else if (msg.data1 == 192 && msg.data2 >= 0 && msg.data2 < 10) {
            // It is in range of the switches, translate to ctrlr 12.
            176 => msg.data1 ;      // chuck Controller into the field
            if (toggle[msg.data2] < 127) {  // switch is off, turn it on
                127 => msg.data3 ;
                127 => toggle[msg.data2] ;
            } else {                        // switch is on, turn it off
                0 => msg.data3 ;
                0 => toggle[msg.data2] ;
            }
            // translate the switch number to a controller number:
            msg.data2 + 12 => msg.data2 ; // controller number
            mout.send(msg);     // send it to output
        }   // ignore all other messages
    }
}
